软件下载 | 资讯教程 | 最近更新 | 下载排行 | 一键转帖 | 发布投稿
您的位置:最火下载站 > 建站程序 > CMS教程 > PHPCMS2008问吧模块安全漏洞的解决办法

PHPCMS2008问吧模块安全漏洞的解决办法

PHPCMS2008问吧模块安全漏洞的解决办法

检查/ask/show.php发现,存在如下脆弱语句

$posts['message'] = $M['use_editor'] ? $posts['message'] : strip_tags($posts['message']);

其中如果使用了在线编辑器,则不会对页面中的html代码进行过滤!这样XSS、iframe攻击将变得轻而易举!!
并且这样的情况在show.php、query.php、question.php中全部存在。
解决办法很简单,对$posts['message']中的HTML代码进行安全过滤。

function stripDangerHtml($str){
$pattern = array(
"/\s+/",
"/<(\/?)(script|i?frame|style|html|body|title|link|meta|\?|\%)([^>]*?)>/isU",
"/(<[^>]*)on[a-zA-Z]+\s*=([^>]*>)/isU",
);
$replacement = array(
" "," ","[url=file://\\1\\2]\\1\\2[/url]",
);
$safeStr = preg_replace($pattern,$replacement,$str);
return $safeStr;
}

    相关阅读
    栏目导航
    推荐软件